(defpackage "SOCKETS-INTERNAL"
  (:nicknames "SOCKINT")
  (:shadow close listen)
  (:use "COMMON-LISP" "ALIEN" "SYSTEM" "EXT" "C-CALL"))

(defpackage "SOCKETS"
  (:export socket unix-socket inet-socket
           make-unix-socket make-inet-socket
           socket-bind socket-accept socket-connect
           socket-send socket-receive socket-recv
           socket-name socket-peername socket-listen
           socket-close socket-file-descriptor socket-make-stream
           get-protocol-by-name
           get-host-by-name

           host-ent
           host-ent-addresses host-ent-address
           host-ent aliases host-ent-name
           
           sockopt-reuse-address

           bad-file-descriptor-error
           address-in-use-error
           interrupted-error
           bad-file-descriptor-error
           invalid-argument-error
           interrupted-error
           out-of-memory-error
           operation-not-supported-error
           operation-not-permitted-error
           protocol-not-supported-error
           network-unreachable-error
           
           make-inet-address
           )
  (:use "COMMON-LISP" "SOCKETS-INTERNAL")
  (:documentation
   "
An OO-ish socket API for CMUCL and SBCL.  Ideas shamelessly stolen from
the BSD socket API for C and Graham Barr's IO::Socket classes for Perl

We borrow the OO concept of the Perl interface, but introduce new
methods to get closer to the flexibility of C, and rename a lot of
methods and arguments to fit Lisp style more closely.

Support structures: socket-address (sockaddr), socket-address-inet
(sockaddr_in), socket-address-unix likewise: work as you'd expect
"
))




