(in-package :entomotomy)

(defmethod cliki:cliki-css-text ((cliki entomotomy-handler) stream)
  (write-sequence
   "HTML { font-family: times,serif; } 
BODY {  background-color: #ffddaa }
H1,H2,H3,H4 { font-family: Helvetica,Arial }
H1 {  color: DarkBlue }
H2 { font-size: 100% }
DIV { margin-left: 5%; margin-right: 5% }
A.internal { color: #0077bb }
A.hyperspec { color: #442266 }
" stream))

(defmethod cliki:cliki-page-header
    ((cliki entomotomy-handler) request title &optional head)
  (let* ((stream (request-stream request))
         (home (cliki:cliki-url-root cliki)))
    (labels ((ahref (l) (urlstring (araneida:merge-url home l)))) 
      (write-sequence
       (html
        `(html
          (head (title ,(format nil "Entomotomy : ~A" title))
           ,@head
           ((link :rel "stylesheet" :href
                  ,(urlstring (merge-url home "admin/cliki.css")))))
          (body
           ((table :width "100%")
            (tr
             (td ((a :href ,(urlstring home))
                  ((img :border 0 :src "http://cvs.telent.net/mantis.png" :alt "[ Home ]"))))
             ((td :colspan 3) (b "Entomotomy") "Zool. the science of the dissection of insects to ascertain their structure, insect anatomy"  (p ((font :size "-1") "No warranty of any kind is made; any implied warranties of <b>merchantability</b> or <b>fitness for a particular purpose</b> are expressly disclaimed")))))
           (center
            (table
             (tr
             (td ((a :href ,(ahref "#")) "[ Home ]"))
             (td ((a :href ,(ahref "Recent%20Changes")) "[ Recent Changes ]"))
             (td ((a :href ,(ahref "CLiki")) "[ About CLiki ]"))
             (td ((a :href ,(ahref "Text%20Formatting")) "[ Text Formatting ]"))
)
             ))
           (hr))))
       stream))))

(defmethod html-for-keyword ((cliki cliki-instance) stream
			     (keyword (eql :sbcl-bug-id))
			     &rest args &aux (arg (car args)))
  (format stream
	  "<b> [ Bug number ~A in the SBCL BUGS file ] </b>"
	  arg))

(defmethod html-for-keyword ((cliki cliki-instance) stream
			     (keyword (eql :patch))
			     &rest args &aux (arg (car args)))
  (destructuring-bind (&key tree (file "") before after) args
    (case tree
      (:sbcl
       (format stream 
	       "<p><b>[ PATCH: </b><pre>cvs -d :pserver:anonymous@cvs.sbcl.sourceforge.net:/cvsroot/sbcl \\
 rdiff -u ~A ~A sbcl/~A</pre><b>]</b>" before after file))
      (:cmucl
       (format stream 
	       "<p><b>[ PATCH: </b><pre>cvs -d :pserver:anonymous@cvs2.cons.org:/home/anoncvs/CVS-cmucl \\
 rdiff -u ~A ~A src/~A</pre><b>]</b>" before after file))
      (t
       (format stream
	       "<pre> [ Can't display patch for unrecognised tree: ~A ] </pre>"
	       args)))))
