(in-package :entomotomy)

(defmethod shared-initialize :after ((handler entomotomy-handler)
				     slot-names &rest initargs)
  ;; I'm prepared to accept that this is tacky.  I'm not about
  ;; to propose a better way to do it, though
  (change-class (find-handler handler "edit/" nil)
		'edit-entomotomy-handler)
  (with-open-file (i (merge-pathnames
		      (make-pathname :name "users" :type "dat"
				     :directory '(:relative "admin"))
		      (cliki-data-directory handler)))
    (let ((*package* #.*package*))
      (setf (cliki-users handler) (read i))))
  (install-handler handler 'login-handler "admin/login" nil))

(defmethod handle-request-authentication ((handler edit-entomotomy-handler)
					 method request)
  (let* ((u (request-cookie request "auth-username"))
	 (colon (position #\: u))
	 (username (urlstring-unescape (subseq u 0 colon)))
	 (password (and colon (urlstring-unescape (subseq u (1+ colon)))))
	 (cliki (request-cliki request))
	 (user (find-user cliki username)))
    (unless (and username password user
		 (string= password (user-password user)))
      (request-send-headers request)
      (princ
       (html
	`(html (head (title "Login"))
	  (body (h1 "Authentication required")
	   (p "We need you to provide a username and password before you can edit this page")
	   ,@(if password `((p "Incorrect password provided")))
	   ((form :method post :action
		  ,(format nil "~Aadmin/login"
			   (urlstring
			    (cliki-url-root cliki))))
	    (p "Name " ((input :name :name :type :text :size 30)))
	    (p "Password"
	       ((input :name :password :type :text :size 30)))
	    (p ((input :name :from :type :hidden :value
		       ,(urlstring (request-url request))))
	       ((input :name login :value "Login" :type submit)))))))
       (request-stream request))
      (signal 'response-sent))
    (setf (request-user request) user)))


(defmethod cliki::html-for-keyword ((cliki entomotomy-handler) stream
				    (keyword (eql :open))
				    &rest args)
  (format stream "<b>[ OPEN: </b>~{~A ~}<b>]</b>" args))
(defmethod cliki::html-for-keyword ((cliki entomotomy-handler) stream
				    (keyword (eql :closed))
				    &rest args)
  (format stream "<b>[ CLOSED: </b>~{~A ~}<b>]</b>" args))


(defmethod cliki::cliki-page-footer
    ((cliki entomotomy-handler) request title)
  (let ((page (cliki::find-page cliki title)))
    (format (request-stream request)
	    "<hr><form action=\"~Aadmin/search\"><a href=\"edit/~A\">Edit page</a> | <a href=\"~A?source\">View source</a> |  Last edit: ~A <p><a href=\"CLiki+Search\"> Search:</a> <input name=words size=60></form>"
	    (urlstring (cliki-url-root cliki))
	    (urlstring-escape title) (urlstring-escape title)
	    (if page
		(cliki::universal-time-to-rfc-date
		 (file-write-date (cliki::page-pathname page)))
		"(none)"))))

#||
(defmethod handle-request-authorization ((handler edit-entomotomy-handler)
					 method request)
  ;; at this point we have a valid user.  Here is where we could introduce
  ;; restrictions of the "user foo is not allowed to to thing bar"
  ;; form
  t)
||#

