(in-package :entomotomy)

(defstruct user name password)

(defmethod find-user ((cliki entomotomy-handler) name)
  (find name (cliki-users cliki)
	:key #'user-name
	:test #'string=))

(defmethod cliki-user-name ((cliki entomotomy-handler) user)
  (user-name user))

(defmethod cliki-user-cookie ((cliki entomotomy-handler) user)
  (format nil "auth-username=~A:~A; path=~A; expires=~A; domain=~A"
	  (urlstring-escape (user-name user))
	  (urlstring-escape (user-password user))
	  (url-path (cliki-url-root cliki))
	  "Sun, 01-Jun-2036 00:00:01 GMT"
	  (url-host (cliki-url-root cliki))))

(defun login-handler (request)
  (let* ((cliki (request-cliki request))
	 (url (request-url request))
	 (body (request-body request))
	 (name (body-param "NAME" body))
	 (from (body-param "FROM" body))
	 (password (body-param "PASSWORD" body))
	 (user (find-user cliki name)))
    (cond ((and user
		(string= password (user-password user)))
	   (request-redirect 
	    request (parse-urlstring from)
	    :set-cookie (cliki-user-cookie cliki user)))
	  (t (request-send-error request 401)))
    (signal 'response-sent)))