(in-package :telentweb)

(defclass alu-cliki (cliki-instance) ())

(defmethod cliki::cliki-page-surround
    ((cliki alu-cliki) request function &key title head)
  (let* ((stream (request-stream request))
	 (page (find-page cliki title))	 )
    (html-stream
     stream
     `(html
       (head (title ,(format nil "ALU Wiki : ~A" title))
	     ,@head
	     ((link :rel "stylesheet" :href
		    "http://www.alu.org/alu/alu.css")))
       (body
	((table :class "main" :border 0 :width "100%" :align :center)
	 (tbody
	  (tr
	   ((td :align :left :width 192)
	    ((a :href "/")
	     ((img :src
		   "http://www.alu.org/alu/images/small-globe-in-parentheses.jpg"
		   :title "ALU Logo" :alt "[ALU Logo]"
		   :style "border: 0px solid ; width: 95px; height: 63px;"))))
	   (td (h1 "ALU Wiki - " ,title))
	   ((td :width "64")))
	  ((tr :valign :top)
	   ((td :class "nav-box")
	    (br)
	    ((p :class "nav-bar") "Wiki")
	    ((p :class "nav-links")
	     "&nbsp;" ((a :href "/") "Home") (br)
	     "&nbsp;" ((a :href "/Recent%20Changes") "Recent Changes") (br)
	     "&nbsp;" ((a :href "/CLiki") "About CLiki") (br)
	     "&nbsp;" ((a :href "/Text%20Formatting") "Text Formatting") (br)
	     "&nbsp;" ((a :href ,(format nil "/edit/~A"
					 (urlstring-escape title)))
		       (b "Edit page")) (br)
	     "&nbsp;" ((a :href "#"
			  :onclick
			  "if(name=window.prompt('New page name ([A-Za-z0-9 ])')) document.location='http://alu.cliki.net/edit/'+name ;return false;")
		       "Create new page"))
"<p class=\"nav-bar\"><a href=\"http://www.alu.org/\">ALU</a></p>
<p class=\"nav-links\">
&nbsp;<a href=\"http://www.alu.org/alu/alu-history.clp\">History</a><br>
&nbsp;<a href=\"http://www.alu.org/alu/alu-board.clp\">Board</a><br>
&nbsp;<a href=\"http://www.alu.org/alu/alu-membership.clp\">Membership</a><br>
&nbsp;<a href=\"http://www.alu.org/alu/alu-contact.clp\">Contact Us</a><br>
</p>"
	    )
	   ((td :class "main-box")
	    ,function))))
	   (br)
	   ((p :class "footer")
	    "Pages on this can be edited by anybody at any time. No warranty of any kind can therefore be made; any implied warranties of merchantability or fitness for a particular purpose are expressly disclaimed. Opinions expressed here are not (except perhaps coincidentally) those of the ALU.")
	   ((p :class "footer")
	    ,(format nil "Powered by <a href=\"http://www.cliki.net/CLiki\">CLiki</a>.  Page last updated: ~A."
		     (if page
			 (cliki::universal-time-to-rfc-date
			  (file-write-date (cliki::page-pathname page)))
			 "(none)"))))))))



