;;;
;;; Cliki.net overrides
;;;

(in-package :telentweb)

(defparameter *cliki-spam-keywords* '("viagra" "cialis" "tramadol"
				      "phentermine"))

(defvar *cliki-spam-scanner* nil)

(defun build-cliki-spam-scanner ()
  (setf *cliki-spam-scanner*
	(cl-ppcre:create-scanner `(:alternation ,@*cliki-spam-keywords*)
				 :case-insensitive-mode t)))

(defmethod cliki::assert-page-content-okay-for-save
  ((cliki cliki::cliki-net) page page-body)

  (when (cl-ppcre:scan *cliki-spam-scanner* page-body)
    (signal 'cliki::cliki-page-save-rejected
	    "Page text triggered spam detector.")))

(build-cliki-spam-scanner)

;;; EOF
