(in-package :telentweb)

(defclass sbcl-cliki (cliki-instance) ())

(defmethod cliki:cliki-css-text ((cliki sbcl-cliki) stream)
  (write-sequence
   "HTML { font-family: times,serif; } 
BODY {  background-color: #ddddff }
H1,H2,H3,H4 { font-family: Helvetica,Arial }
H1 {  color: DarkBlue }
H2 { font-size: 100% }
DIV { margin-left: 5%; margin-right: 5% }
A.internal { color: #0077bb }
A.hyperspec { color: #442266 }
" stream))

(defmethod cliki:cliki-page-header
    ((cliki sbcl-cliki) request title &optional head)
  (let* ((stream (request-stream request))
         (home (cliki:cliki-url-root cliki)))
    (labels ((ahref (l) (urlstring (araneida:merge-url home l)))) 
      (write-sequence
       (html
	`(html
	  (head (title ,(format nil "SBCL Internals : ~A" title))
	   ,@head
	   ((link :rel "stylesheet" :href
		  ,(urlstring (merge-url home "admin/cliki.css")))))
	  (body
	   ((table :width "100%")
	    (tr
	     (td ((a :href ,(urlstring home))
		  ((img :border 0 :src "/sbcli.png" :alt "[ Home ]"))))
	     ((td :colspan 3) (center "SBCL Internals") (br) "The pages on this CLiki-driven site can be edited by anybody at any time.  No warranty of any kind can therefore be made; any implied warranties of <b>merchantability</b> or <b>fitness for a particular purpose</b> are expressly disclaimed")))
	   (center
	    (table
	     (tr
	     (td ((a :href ,(ahref "#")) "[ Home ]"))
	     (td ((a :href ,(ahref "Recent%20Changes")) "[ Recent Changes ]"))
	     (td ((a :href ,(ahref "CLiki")) "[ About CLiki ]"))
	     (td ((a :href ,(ahref "Text%20Formatting")) "[ Text Formatting ]")))
	     ))
	   (hr))))
       stream))))