(in-package :telentweb)

(defclass toffeesix-cliki (authed-cliki-handler) ())

(defmethod cliki-default-page-name ((cliki toffeesix-cliki))
  "empty docstring"
  "Welcome")

(defmethod cliki:cliki-css-text ((cliki toffeesix-cliki) stream)
  (write-sequence
   "
HTML { font: Tahoma,sans-serif; } 
BODY {  background-color: white; font: \"Tahoma\"; } 
H1,H2,H3,H4 { font-family: Tahoma }
H1 {  size: 120%; color: \"Teal\" }
A.LEFT { font-family: Helvetica,Arial; text-style: bold; text-decoration: none; color: \"white\" }
A.LEFT:HOVER { font-family: Helvetica,Arial; text-style: bold; text-decoration: underline; }
H2 { font-size: 100% ; color: \"Teal\" }
P { font: 12Tahoma; }
LI { font: 12Tahoma; }
BLOCKQUOTE { font: 12Tahoma; }
" stream))


(defmethod cliki:cliki-page-header
    ((cliki toffeesix-cliki) request title &optional head)
  (let* ((stream (request-stream request))
         (home (cliki:cliki-url-root cliki)))
    (let* ((s
	    (html
	     `(html
	       (head (title ,(format nil "toffeesix - ~A" title))
		,@head
		((link :rel "stylesheet" :href
		       ,(urlstring (merge-url home "admin/cliki.css")))))
	       (body
		((table :width "100%")
		 ((tr :valign :top)
		  ((td :align left :width "15%"
		       :foreground "white" :bgcolor "teal" :height "100%")
		   (p "&nbsp;")
		   #+nil
		   ((a :class "left" :href  ,(urlstring home))
		    ((img :border 0 :src "images/toffeesix.png" :alt "[ Home ]")))
		   (p) ((a :class "LEFT" :href  "Welcome") "Welcome") 
		   (p) ((a :class "LEFT" :href  "The_Story_so_Far") "The Story So Far" )
		   (p) ((a :class "LEFT" :href  "Service") "Service" )
		   (p) ((a :class "LEFT" :href  "Reception_Lunch") "Reception Lunch") 
		   (p) ((a :class "LEFT" :href  "Reception_Party") "Reception Party") 
		   (p) ((a :class "LEFT" :href  "Directions") "Directions") 
		   (p) ((a :class "LEFT" :href  "Local_Information") "Local Information") 
		   (p) ((a :class "LEFT" :href  "Gifts") "Gifts") 
		   (p) ((a :class "LEFT" :href  "Thanks") "Thanks to ...") 
		   (p) ((a :class "LEFT" :href  "RSVP") "R.S.V.P "))
		  ((td)
					;(h1 ,title)
		   (foo))))))))
	   (end (search "<FOO" s)))
      (write-sequence s stream :end end))))

(defmethod cliki:cliki-page-footer
    ((cliki toffeesix-cliki) request title)
  (let ((page (cliki::find-page cliki title)))
    (write-sequence
     "</td></tr></table>"      (request-stream request))
    (html-stream
     (request-stream request)
     `((blank)
       (hr)
       ((font :size 2)
	" Page last updated: "
	,(cliki::universal-time-to-rfc-date
	  (file-write-date (cliki::page-pathname page))))))))

(defmethod shared-initialize :after ((handler toffeesix-cliki)
				     slot-names &rest initargs)
  (install-handler
   handler (make-instance 'araneida:static-file-handler
			  :pathname (merge-pathnames
				     "images/"
				     (cliki:cliki-data-directory handler)))
   "images/" nil))
