(in-package :telentweb)

(defvar *home-page-hits* 0)
(defun another-hit ()
  (princ-to-string (incf *home-page-hits*)))

(defvar *telent-url* (make-instance 'http-url :host *telent-site-name*))
(defvar *telent-server*
  (make-instance 'server
                 :name *telent-site-name*
                 :base-url *telent-url* :port 8000))
(export-server *telent-server*)


(defun counter-handler (request rest-of-url)
  (http-server:request-send-headers request)
  (princ
   (html
    `(html
      (head ((link :rel "stylesheet" :href "/dan.css"))
            (title "Telent Netowrks"))
      (body
       (h1 "Telent Netowrks")
       (p ,(urlstring (request-url request)))
       (p (i "Networking solutions for poor typists"))
       (p ,(another-hit) " hits to this page since I last restarted Lisp"))))
   (request-stream request)))

(export-handler (merge-url *telent-url* "/counter") 
                'counter-handler :match :prefix :method t :stage :response)

(export-handler *telent-url*
                `(file-request-handler ,*static-pages-directory*)
                :method t)

(export-handler (merge-url *telent-url* "/code/")
		`(file-request-handler ,*lisp-source-directory*)
		:method t)

(export-handler (merge-url *telent-url* "/wait")
                (lambda (r rest)
                  (httpsrv:request-send-headers r :content-type "text/plain")
                  (sleep 15)
                  (princ "done" (request-stream r)))
                :match :exact)

(export-handler (merge-url *telent-url* "/lisp/")
                (lambda (r rest)
                  (format t "Logging ~A~%" (request-url r)))
                :stage :log)

(export-handler (merge-url *telent-url* "/error")
                (lambda (r rest) (/ 1 0)))

(export-handler *telent-url*
                (lambda (r rest)
                  (format t "Error: ~A~%" (request-condition r))
                  (request-send-error r 500
                                      (format nil "~A" (request-condition r))))
                :stage :error)
                

(defun run ()
  (discard-errors
   'httpsrv:server-start))


;; OK, let's roll

(with-open-file (conf *apache-config-segment*
                      :direction :output
                      :if-does-not-exist :create)
  (output-apache-conf conf))

(format t "Bits of apache config file are to be found in \"~A\"
Evaluate (RUN) to start up"
        *apache-config-segment*)



